using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;

using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using ScreenManager;
using LabirintGUI.Screens;

namespace LabirintGUI
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
          

            graphics.PreferredBackBufferWidth = GraphicsAdapter.DefaultAdapter.CurrentDisplayMode.Width;
            graphics.PreferredBackBufferHeight = GraphicsAdapter.DefaultAdapter.CurrentDisplayMode.Height;
            graphics.PreferMultiSampling = false;
            graphics.IsFullScreen = true;
           
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            Properties.soundOn = true;
            Properties.musicOn = true;
            Properties.resolution = new Vector2(1280, 768);
            Properties.fullScreenOn = true;

            SCREEN_MANAGER.add_screen(new MainScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new NewGameScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new HelpScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new SettingsScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new AboutScreen(GraphicsDevice));

            SCREEN_MANAGER.goto_screen("main");

            
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
       




        protected override void LoadContent()
        {
            
                //this.MainSpriteBatch = new SpriteBatch(graphics.GraphicsDevice);
               // this.Background  = Content.Load<Texture2D>(@"main-cb");
                  SCREEN_MANAGER.Init(this);        
 
           
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            SCREEN_MANAGER.Update(gameTime);
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            SCREEN_MANAGER.Draw(gameTime);
            base.Draw(gameTime);
        }
    }
}
